module Actionable
  module MemoryStore

    def self.insert(model)
      key = (model[:id] ||= BSON::ObjectId.new.to_s)
      set(key,model)
      add(hash["target_#{model[:target_id]}"],model) if model[:target_id].present?
      model
    end

    def self.find(key)
      model = hash[key]
    end

    def self.find_by_target_id(target_id)
      hash["target_#{target_id}"]
    end

    private

    def self.hash
      @hash ||= {}
    end

    def self.set(key,value)
      hash[key] = value
    end

    def self.get(key)
      hash[key]
    end

    def self.clear
      @hash = {}
    end

    def self.count
      hash.length
    end

    def self.add(key,model)
      list = (hash[key] ||= [])
      list << model
      set(key,list)
    end


  end
end