require 'actionable/sweep'

module Resque
  class Worker

    alias :default_reserve :reserve

    def reserve
      default_reserve || sweep
    end

    def sweep
      if Resque.size('actionable_sweep') < 1
        Resque.enqueue(Actionable::Sweep)
      end
      nil
    end

  end
end
