require 'mongoid'

module Actionable
  module MongoidStore
    
    def self.find(key)
      Action.find(key)
    end

    def self.find_by_target_id(target_id)
      Action.where(target_id:target_id)
    end

    def self.count
      Action.count
    end

    def self.create(*args)
      Action.create(*args)
    end

    def self.build(*args)
      Action.build(*args)
    end

  end
end